=== debian/changelog ===
dolfin (1.0.0-7) unstable; urgency=low

  * debian/control:
    - Remove Conflicts and Replaces from binary package libdolfin1.0-dbg.
    - Update long description for all packages.
    - Add python-netcdf to Depends for binary package python-dolfin
      (closes: #674014).
    - Require SWIG upstream version 2.0.7 for binary package
      python-dolfin (closes: #675207).
    - Require UFC >= 2.0.5-3.

 -- Johannes Ring <johannr@simula.no>  Fri, 29 Jun 2012 09:45:28 +0200

dolfin (1.0.0-6) unstable; urgency=low

  * debian/rules: Set default Python version to fix FTBFS when Python3
    is available (closes: #672952).
  * debian/control: Remove Provides: libdolfin0-dev from
    libdolfin1.0-dev (and same to -dbg package).

 -- Johannes Ring <johannr@simula.no>  Mon, 21 May 2012 10:09:59 +0200

dolfin (1.0.0-5) unstable; urgency=low

  * Add patches to fix problems with SWIG 2.0.5 and GCC 4.7.
  * debian/control: Require UFC >= 2.0.5-2.

 -- Johannes Ring <johannr@simula.no>  Mon, 14 May 2012 11:25:47 +0200

dolfin (1.0.0-4) unstable; urgency=low

  * debian/watch: Replace http with https in URL.
  * debian/control:
    - Add libcgal-dev to Build-Depends and Depends for binary package
      libdolfin1.0-dev.
    - Bump Standards-Version to 3.9.3 (no changes needed).
  * debian/rules:
    - Enable CGAL support.
    - Call dh_numpy in binary-install/python-dolfin target to fix
      lintian error missing-dependency-on-numpy-abi.

 -- Johannes Ring <johannr@simula.no>  Tue, 20 Mar 2012 14:47:27 +0100

dolfin (1.0.0-3) unstable; urgency=low

  * Disable building with PETSc, SLEPc and SCOTCH on some arches.

 -- Johannes Ring <johannr@simula.no>  Tue, 14 Feb 2012 11:46:11 +0100

dolfin (1.0.0-2) unstable; urgency=low

  * debian/control:
    - Replace libpetsc3.1-dev and libslepc3.1-dev with libpetsc3.2-dev
      and libslepc3.2-dev, respectively.
    - Require libptscotch-dev, libpetsc3.2-dev and libslepc3.2-dev on
      all arches.
  * debian/rules: Help CMake find version 3.2 of PETSc and SLEPc by
    defining PETSC_DIR and SLEPC_DIR variables, respectively.

 -- Johannes Ring <johannr@simula.no>  Mon, 30 Jan 2012 11:45:31 +0100

dolfin (1.0.0-1) unstable; urgency=low

  * New upstream release.
  * debian/control:
    - Bump version numbers for python-ufc, python-ffc, python-viper,
      python-ufl and python-instant in Depends field for binary package
      python-dolfin.
    - Bump version numbers for ufc and python-ufc in Build-Depends and
      in Depends field for binary package libdolfin1.0-dev.

 -- Johannes Ring <johannr@simula.no>  Thu, 08 Dec 2011 08:47:31 +0100
