=== debian/watch ===
version=3
https://launchpad.net/dolfin/+download https://launchpad.net/dolfin/.*/dolfin-(.*)\.tar\.gz
